#!/bin/bash
## Project:
#SBATCH --account=NN9526K
## Job name:
#SBATCH --job-name=python_g4
#SBATCH -p normal
## Wall time limit:
#SBATCH --time=0-20:0:0
## Number of nodes and task er node
#SBATCH --nodes=10 --ntasks-per-node=4
#SBATCH --mail-user=david.sarria@uib.no


## Recommended safety settings:
set -o errexit # Make bash exit on any error
set -o nounset # Treat unset variables as errors

## Software modules
module restore system   # Restore loaded modules to the default

module load foss/2017a
module load CMake/3.9.1
module load GCCcore/6.4.0
module load Python/2.7.13-intel-2017a
module load Boost/1.63.0-intel-2017a-Python-2.7.13

module list             # List loaded modules, for easier debugging


## Run the application

#export SCRATCH=/cluster/work/jobs/$SLURM_JOB_ID 
#cp -R * $SCRATCH
#cd $SCRATCH/build/
#copyback ./output/*

cd /cluster/work/users/dsarria/G4_projects/HEAP/av_prob/GEANT4/code/build/

srun python g4_script_auto_mpi.py

